From 1df8286de8ac4eed649bb389d90370cc0977b103 Mon Sep 17 00:00:00 2001
From: Alexey Min <alexey.min@gmail.com>
Date: Wed, 1 Jul 2020 08:34:10 +0300
Subject: [PATCH 26/59] AlpineApkUpdater: update progressing status

---
 .../AlpineApkBackend/AlpineApkUpdater.cpp     | 25 +++++++++++--------
 .../AlpineApkBackend/AlpineApkUpdater.h       |  2 +-
 2 files changed, 16 insertions(+), 11 deletions(-)

diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.cpp b/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.cpp
index 0083f340d..2f3d184fb 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.cpp
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.cpp
@@ -125,20 +125,18 @@ QDateTime AlpineApkUpdater::lastUpdate() const
 bool AlpineApkUpdater::isCancelable() const
 {
     qCDebug(LOG_ALPINEAPK) << Q_FUNC_INFO;
-    return true;
+    return false;
 }
 
 bool AlpineApkUpdater::isProgressing() const
 {
-    qCDebug(LOG_ALPINEAPK) << Q_FUNC_INFO;
-    return false;
+    qCDebug(LOG_ALPINEAPK) << Q_FUNC_INFO << m_progressing;
+    return m_progressing;
 }
 
 bool AlpineApkUpdater::isMarked(AbstractResource *res) const
 {
-    // qCDebug(LOG_ALPINEAPK) << Q_FUNC_INFO;
     return m_markedToUpdate.contains(res);
-    // return true;
 }
 
 void AlpineApkUpdater::fetchChangelog() const
@@ -148,7 +146,6 @@ void AlpineApkUpdater::fetchChangelog() const
 
 double AlpineApkUpdater::updateSize() const
 {
-    // qCDebug(LOG_ALPINEAPK) << Q_FUNC_INFO;
     double sum = 0.0;
     for (AbstractResource *res : m_markedToUpdate) {
         sum += res->size();
@@ -170,8 +167,6 @@ void AlpineApkUpdater::cancel()
 void AlpineApkUpdater::start()
 {
     qCDebug(LOG_ALPINEAPK) << Q_FUNC_INFO;
-    //return;
-//#if 0
     KAuth::Action upgradeAction(QStringLiteral("org.kde.discover.alpineapkbackend.upgrade"));
     upgradeAction.setHelperId(QStringLiteral("org.kde.discover.alpineapkbackend"));
 
@@ -196,8 +191,10 @@ void AlpineApkUpdater::start()
     QObject::connect(reply, &KAuth::ExecuteJob::result,
                      this, &AlpineApkUpdater::handleKAuthUpgradeHelperReply);
 
+    m_progressing = true;
+    Q_EMIT progressingChanged(m_progressing);
+
     reply->start();
-//#endif
 }
 
 void AlpineApkUpdater::proceed()
@@ -207,7 +204,7 @@ void AlpineApkUpdater::proceed()
 
 int AlpineApkUpdater::updatesCount()
 {
-    // qDebug(LOG_ALPINEAPK) << Q_FUNC_INFO << m_updatesCount;
+    qDebug(LOG_ALPINEAPK) << Q_FUNC_INFO << m_updatesCount;
     return m_updatesCount;
 }
 
@@ -241,6 +238,10 @@ void AlpineApkUpdater::startCheckForUpdates()
     QObject::connect(reply, QOverload<KJob *, unsigned long>::of(&KAuth::ExecuteJob::percent),
                      this, &AlpineApkUpdater::handleKAuthUpdateHelperProgress);
 
+    m_progressing = true;
+    Q_EMIT progressingChanged(m_progressing);
+    Q_EMIT progressChanged(0);
+
     reply->start();
 }
 
@@ -256,6 +257,9 @@ void AlpineApkUpdater::handleKAuthUpdateHelperReply(KJob *job)
         handleKAuthHelperError(reply, replyData);
     }
 
+    m_progressing = false;
+    Q_EMIT progressingChanged(m_progressing);
+
     // we are not in the state "Fetching updates" now, update UI
     Q_EMIT checkForUpdatesFinished();
 }
@@ -265,6 +269,7 @@ void AlpineApkUpdater::handleKAuthUpdateHelperProgress(KJob *job, unsigned long
     Q_UNUSED(job)
     qCDebug(LOG_ALPINEAPK) << "    fetch updates progress: " << percent;
     Q_EMIT fetchingUpdatesProgressChanged(percent);
+    Q_EMIT progressChanged(static_cast<qreal>(percent));
 }
 
 void AlpineApkUpdater::handleKAuthUpgradeHelperReply(KJob *job)
diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.h b/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.h
index 77140ca25..0ee2fcb47 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.h
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.h
@@ -185,7 +185,7 @@ private:
 
 //    QSet<AbstractResource*> m_upgradeable;
 //    QSet<AbstractResource*> m_pendingResources;
-//    bool m_settingUp;
+    bool m_progressing = false;
 //    qreal m_progress;
 //    QDateTime m_lastUpdate;
 //    QTimer m_timer;
-- 
GitLab


